#include maps\mp\_utility;

onPlayer_Connect()
{
	self.pers["killer"] = 0;

	lpselfnum = self getEntityNumber();

	level.R_U_Name[lpselfnum] = self.name;
	level.R_U_State[lpselfnum] = "notready";
	self.R_U_Looping = 0;

	if (game["mode"] == "pub") return;

	if(isDefined(level.rdyup) && level.rdyup)
	{
		self.statusicon = "party_notready";
		self thread readyup(lpselfnum);
	}
}

onPlayer_Disconnect()
{
	lpselfnum = self getEntityNumber();

	level.R_U_Name[lpselfnum] = "disconnected";
	level.R_U_State[lpselfnum] = "disconnected";
	self.R_U_Looping = 0;

	if(level.rdyup == 1)
		thread Check_All_Ready();
}

Ready_UP()
{
	wait 0;

	level.rdyup = 1;
	level.warmup = 0;
	level.playersready = false;
	if (!isdefined(game["firstreadyupdone"]) )
		game["firstreadyupdone"] = 0;

	// Password Checker
	if(isDefined(game["halftimeflag"]) && !game["halftimeflag"])
		thread Password_Check();


	//Remove MG nests
	deletePlacedEntity("misc_turret");
	deletePlacedEntity("misc_mg42");


	// Ready-Up Mode HUD
	level.waiting = newHudElem();
	level.waiting.alignX = "center";
	level.waiting.alignY = "middle";
	level.waiting.color = (.8, 1, 1);
	level.waiting.x = 320;
	level.waiting.y = 370;
	level.waiting.fontScale = 1.2;
	level.waiting.font = "default";
	level.waiting setText(game["waiting"]);

	setClientNameMode("manual_change");
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		player.pers["killer"] = 0;

		lpselfnum = player getEntityNumber();
		player.statusicon = "party_notready";
		level.R_U_Name[lpselfnum] = player.name;
		level.R_U_State[lpselfnum] = "notready";
		player.R_U_Looping = 0;

		player thread readyup(lpselfnum);
	}

	Waiting_On_Players();

	if(isdefined(level.waiting))
		level.waiting destroy();

	setClientNameMode("auto_change");
	game["dolive"] = 1;
	level.rdyup = 0;
	level.warmup = 1;

	Warn_Match_Start();
	[[level.pam_hud]]("kill_all");
}

Waiting_On_Players()
{
	wait 0;
	wait_on_timer = 0;

	level.waitingon = newHudElem(self);
	level.waitingon.x = 575;
	level.waitingon.y = 45;
	level.waitingon.alignX = "center";
	level.waitingon.alignY = "middle";
	level.waitingon.fontScale = 1.2;
	level.waitingon.font = "default";
	level.waitingon.color = (.8, 1, 1);
	level.waitingon setText(game["waitingon"]);

	level.playerstext = newHudElem(self);
	level.playerstext.x = 575;
	level.playerstext.y = 85;
	level.playerstext.alignX = "center";
	level.playerstext.alignY = "middle";
	level.playerstext.fontScale = 1.2;
	level.playerstext.font = "default";
	level.playerstext.color = (.8, 1, 1);
	level.playerstext setText(game["playerstext"]);

	level.notreadyhud = newHudElem(self);
	level.notreadyhud.x = 575;
	level.notreadyhud.y = 65;
	level.notreadyhud.alignX = "center";
	level.notreadyhud.alignY = "middle";
	level.notreadyhud.fontScale = 1.2;
	level.notreadyhud.font = "default";
	level.notreadyhud.color = (.98, .98, .60);

	while(!level.playersready)
	{
		notready = 0;

		players = getentarray("player", "classname");
		for(i = 0; i < players.size; i++)
		{
			player = players[i];

			lpselfnum = player getEntityNumber();
			if (level.R_U_State[lpselfnum] == "notready")
			{
				notready++;
				player.statusicon = "party_notready";
			}
		}

		level.notreadyhud setValue(notready);

		wait level.fps_multiplier * .5;
	}

	if(isdefined(level.notreadyhud))
		level.notreadyhud destroy();
	if(isdefined(level.waitingon))
		level.waitingon destroy();
	if(isdefined(level.playerstext))
		level.playerstext destroy();
}

readyup(entity)
{
	wait level.fps_multiplier * .5; // Required or the "respawn" notify could happen before it's waittill has begun

	// Check to see if we have already have this player in the ready-up loop
	if (self.R_U_Looping == 1)
		return;

	self.R_U_Looping = 1;

	playername = level.R_U_Name[entity];

	//Debug
	if (self.name == "bot0" ||
		self.name == "bot1" ||
		self.name == "bot2" ||
		self.name == "bot3" ||
		self.name == "bot4" ||
		self.name == "bot5" ||
		self.name == "bot6" ||
		self.name == "bot7" ||
		self.name == "bot8" ||
		self.name == "bot9")
	{
		level.R_U_State[entity] = "ready";
		return;
	}

	//TWL Warning
	self TWL_Warning();

	if (!isdefined(self) || !isPlayer(self))
	{
		level.R_U_State[entity] = "disconnected";
		level.R_U_Name[entity] = "disconnected";
		wait level.fps_multiplier * 0.5;

		thread Check_All_Ready();
		return;
	}

	//Announce what Team the player is on
	if (!isDefined(game["firstreadyupdone"]))
		game["firstreadyupdone"] = 0;

	if ( (self.pers["team"] == "axis" && game["firstreadyupdone"]  == 0) || (self.pers["team"] == "allies" && game["firstreadyupdone"] != 0) )
		self iprintlnbold("^7You are on ^3Team 1");
	else
		self iprintlnbold("^7You are on ^3Team 2");
	
	self iprintlnbold("^7Hit the ^3-Use- ^7key to Ready-Up");

	status = newClientHudElem(self);
	status.x = 575;
	status.y = 120;
	status.alignX = "center";
	status.alignY = "middle";
	status.fontScale = 1.2;
	status.font = "default";
	status.color = (.8, 1, 1);
	status setText(game["status"]);

	readyhud = newClientHudElem(self);
	readyhud.x = 575;
	readyhud.y = 135;
	readyhud.alignX = "center";
	readyhud.alignY = "middle";
	readyhud.fontScale = 1.2;
	readyhud.font = "default";
	readyhud.color = (1, .66, .66);
	readyhud setText(game["notready"]);

	self thread Ready_Up_Kill_Counter();

	while(!level.playersready)
	{
		if (!isdefined(self) || !isPlayer(self))
		{
			level.R_U_State[entity] = "disconnected";
			level.R_U_Name[entity] = "disconnected";
			wait level.fps_multiplier * 0.5;

			thread Check_All_Ready();
			return;
		}
		if(self useButtonPressed() == true)
		{
			if (level.R_U_State[entity] == "notready")
			{
				level.R_U_State[entity] = "ready";
				self.statusicon = "party_ready";
				//iprintln(playername + "^2 is Ready");
				logPrint(playername + ";" + " is Ready Logfile;" + "\n");

				// change players hud to indicate player not ready
				readyhud.color = (.73, .99, .73);
				readyhud setText(game["ready"]);

				wait level.fps_multiplier * 1;
				thread Check_All_Ready();

			}
			else if (level.R_U_State[entity] == "ready")
			{
				level.R_U_State[entity] = "notready";
				self.statusicon = "party_notready";
				//iprintln(playername + "^1 is Not Ready");
				logPrint(playername + ";" + " is Not Ready Logfile;" + "\n");

				// change players hud to indicate player not ready
				readyhud.color = (1, .84, .84);
				readyhud setText(game["notready"]);
				wait level.fps_multiplier * 1;
			}
			while (self useButtonPressed() == true)
				wait level.frame;
		}
		else
			wait level.fps_multiplier * .1;

		if (level.R_U_State[entity] == "disconnected")
		{
			//self.R_U_Looping = 0;
			level.R_U_Name[entity] = "disconnected";
			return;
		}
	}

	if(isdefined(readyhud))
		readyhud destroy();
	if(isdefined(status))
		status destroy();
}

Check_All_Ready()
{
	wait level.fps_multiplier * .1;
	checkready = true;

	// Check to see if all players are looping
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		lpselfnum = player getEntityNumber();

		if (!isdefined(player.R_U_Looping) )
		{
			level.R_U_Name[lpselfnum] = self.name;
			level.R_U_State[lpselfnum] = "notready";
			player.R_U_Looping = 0;
		}
			
		if (player.R_U_Looping == 0)
		{
			player thread readyup(lpselfnum);
			return;
		}

		//Player is looping, now see if he is ready
		if (level.R_U_State[lpselfnum] == "notready")
			checkready = false;
	}

	// See if checkready is still true
	if (checkready == true)
		level.playersready = true;
}

TWL_Warning()
{
	mode = getcvar("pam_mode");
	switch (mode)
	{
	case "twl_ladder": 
	case "twl_league": 
	case "twl_rifles": 
	case "twl_stock": 
	case "twl_eu_ladder": 
	case "twl_eu_league": 
	case "twl_eu_rifles": 
	case "twl_eu_rifles_league": 
		x = 1; 
		break;

	case "ecw":
		x = 2;
		break;

	default:
		x = 0;
		break;
	}
	if (x == 1)
	{
		self iprintlnbold("^2By Readying-Up, you are ^3AGREEING ^2to");
		self iprintlnbold("^2the match conditions on this server.");
		wait level.fps_multiplier * 7.8;

		self iprintlnbold("^2If you have ^3ANY ^2concerns, please contact an");
		if(game["halftimeflag"] == 0)
			self iprintlnbold("^2admin on #twl_cod ^3BEFORE ^2beginning the match");
		else
			self iprintlnbold("^2admin on #twl_cod ^3BEFORE ^2continuing the match");
		wait level.fps_multiplier * 7.8;

		self iprintlnbold("^2Issues that could have been settled ^3BEFORE");
		self iprintlnbold("^2starting are ^3non-disputable");
		wait level.fps_multiplier * 6.8;
	}
	else if (x == 2)
	{
		self iprintlnbold("^2By Readying-Up, you are ^3AGREEING ^2to");
		self iprintlnbold("^2the match conditions on this server.");
		wait level.fps_multiplier * 7.8;

		self iprintlnbold("^2If you have ^3ANY ^2concerns, please contact an");
		if(game["halftimeflag"] == 0)
			self iprintlnbold("^2ECW admin ^3BEFORE ^2beginning the match");
		else
			self iprintlnbold("^2ECW admin ^3BEFORE ^2continuing the match");
		wait level.fps_multiplier * 7.8;

		self iprintlnbold("^2Issues that could have been settled ^3BEFORE");
		self iprintlnbold("^2starting are ^3non-disputable");
		wait level.fps_multiplier * 6.8;
	}
}

Match_Mode_Readyup()
{
	thread [[level.pam_hud]]("header");

	Ready_UP();

	// get rid of warmup weapons
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{ 
		//drop other weapons
		player = players[i];

		player.pers["weapon1"] = undefined;
		player.pers["weapon2"] = undefined;
		player setWeaponSlotWeapon("primaryb", "none");
		player maps\pam\weapons::givePistol();
		player.pers["spawnweapon"] = player.pers["selectedweapon"];

		player unlink();
	}

	game["matchstarted"] = true;

	if (!game["halftimeflag"])
	{
		reset_ALL_Scores();
		logPrint("MS\n");
	}

	game["Do_Ready_up"] = 0;

	if (!level.pam_mode_change)
		map_restart(true);
}

reset_ALL_Scores()
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		player.pers["score"] = 0;
		player.pers["deaths"] = 0;
	}

	game["alliedscore"] = 0;
	setTeamScore("allies", game["alliedscore"]);
	game["axisscore"] = 0;
	setTeamScore("axis", game["axisscore"]);

	game["half_1_allies_score"] = 0;
	game["half_1_axis_score"] = 0; 
	game["half_2_allies_score"] = 0;
	game["half_2_axis_score"] = 0;
	game["Team_1_Score"] = 0;
	game["Team_2_Score"] = 0;
}

Warn_Match_Start()
{
	if (!isDefined(level.half_start_timer))
		level.half_start_timer = 10;

	 thread [[level.pam_hud]]("players_ready");
	 thread Record_HUD_Reminder();

	 wait level.fps_multiplier * 3;
	
	thread [[level.pam_hud]]("half_start", level.half_start_timer);
	wait level.fps_multiplier * level.half_start_timer;
}


Ready_Up_Respawn(deathAnimDuration)
{
	self.pers["weapon1"] = undefined;
	self.pers["weapon2"] = undefined;
	self.pers["spawnweapon"] = undefined;

	if(!isdefined(self.switching_teams))
	{
		body = self cloneplayer(deathAnimDuration);
		thread maps\pam\deathicons::addDeathicon(body, self.clientid, self.pers["team"], 5);
	}
	self.switching_teams = undefined;
	self.joining_team = undefined;
	self.leaving_team = undefined;

	wait level.fps_multiplier * 2;	// required for Callback_PlayerKilled to complete before killcam can execute

	self stopShellshock();
	self stoprumble("damage_heavy");

	if (self.pers["team"] == "spectator")
		return;

	if ( isDefined(self.pers["weapon"]) && !isAlive(self) )
	{
		self.sessionteam = self.pers["team"];
		self.sessionstate = "playing";
		self.spectatorclient = -1;
		self.archivetime = 0;
		self.psoffsettime = 0;
		//self.statusicon = "";
		self.maxhealth = 100;
		self.health = self.maxhealth;
		self.friendlydamage = undefined;
		self.spawned = true;

		if(self.pers["team"] == "allies")
			spawnpointname = "mp_sd_spawn_attacker";
		else
			spawnpointname = "mp_sd_spawn_defender";

		spawnpoints = getentarray(spawnpointname, "classname");
		spawnpoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_Random(spawnpoints);

		if(isdefined(spawnpoint))
			self spawn(spawnpoint.origin, spawnpoint.angles);
		else
			maps\mp\_utility::error("NO " + spawnpointname + " SPAWNPOINTS IN MAP");

		if(!isdefined(self.pers["savedmodel"]))
			maps\mp\gametypes\_teams::model();
		else
			maps\mp\_utility::loadModel(self.pers["savedmodel"]);

		self setWeaponSlotWeapon("primary", self.pers["weapon"]);
		if (getcvar("g_gametype") != "bash")
		{
			self setWeaponSlotAmmo("primary", 999);
			self setWeaponSlotClipAmmo("primary", 999);

			self setSpawnWeapon(self.pers["weapon"]);

			maps\pam\weapons::givePistol();
			maps\pam\weapons::giveGrenades();
			maps\pam\weapons::giveBinoculars();
		}
		else
		{
			self setWeaponSlotAmmo("primary", 0);
			self setWeaponSlotClipAmmo("primary", 0);

			self setSpawnWeapon(self.pers["weapon"]);

			if (level.bash_pistols)
			{
				maps\mp\gametypes\_weapons::givePistol();
				self setWeaponSlotAmmo("primaryb", 0);
				self setWeaponSlotClipAmmo("primaryb", 0);
			}
		}

		self.usedweapons = false;
	}
}

Password_Check()
{
	if (getcvar("g_password") != "")
		return;

	no_pass = newHudElem();
	no_pass.x = 320;
	no_pass.y = 50;
	no_pass.alignX = "center";
	no_pass.alignY = "top";
	no_pass.fontScale = 1.2;
	no_pass.color = (1, 1, 0);
	no_pass setText(game["no_password"]);

	while ( getcvar("g_password") == "" )
		wait level.fps_multiplier * .75;

	if ( isDefined(no_pass) )
		no_pass destroy();
}

Ready_Up_Kill_Counter()
{
	self endon("disconnect");

	if (!isdefined(self))
		return;

	self.ru_kills = 0;

	ru_kill_count = newClientHudElem(self);
	ru_kill_count.x = 320;
	ru_kill_count.y = 25;
	ru_kill_count.alignX = "center";
	ru_kill_count.alignY = "middle";
	ru_kill_count.fontScale = 1.4;
	ru_kill_count.font = "default";
	ru_kill_count.color = (.73, .99, .73);
	ru_kill_count setValue(self.ru_kills);

	changed = 0;
	while(!level.playersready)
	{
		wait level.fps_multiplier * .5;

		if (!isdefined(self))
			return;

		if(!changed)
		{
			if(self.pers["killer"])
			{
				ru_kill_count.color = (1, .84, .84);
				changed = 1;
				ru_kill_count setValue(self.ru_kills);
			}
		}
		else
			ru_kill_count setValue(self.ru_kills);
	}
}

Record_HUD_Reminder()
{
	level.record_reminder = newHudElem();
	level.record_reminder.x = 320;
	level.record_reminder.y = 320;
	level.record_reminder.alignX = "center";
	level.record_reminder.alignY = "middle";
	level.record_reminder.fontScale = 1.2;
	level.record_reminder.font = "default";
	level.record_reminder.color = (.8, 1, 1);
	level.record_reminder.alpha = 1;
	level.record_reminder setText(game["rec_remind"]);

	while(!level.playersready)
		wait level.fps_multiplier * 0.5;

	for (i=1;i<20;i++)
	{
		wait level.fps_multiplier * 1.5;
		if (level.record_reminder.alpha)
			level.record_reminder.alpha = 0;
		else
			level.record_reminder.alpha = 1;
	}
}