Rules()
{
	// Match Style 
	setcvar("scr_ctf_timelimit", 20);
	setcvar("scr_ctf_timelimit_halftime", 0);
	setcvar("scr_ctf_half_score", 0);
	setcvar("scr_ctf_end_score", 7);
	setcvar("scr_ctf_end_half2score", 0);

	setcvar("scr_flag_autoreturn_time", 60);
	setcvar("scr_ctf_respawn_time", 10);

	// Are there OT Rules?
	setcvar("g_ot", 1);

	//OT Rules 
	if (getcvarint("g_ot_active") > 0) //1st OT 
	{ 
		setcvar("scr_ctf_scorelimit", 1);
		setcvar("scr_ctf_end_score", 1); 
	} 

	// Between Half Timer 
	setcvar("g_matchwarmuptime", 10); 


	// Between Round/Half Timers
	setcvar("g_matchwarmuptime", 10);
	setcvar("g_roundwarmuptime", 5);


	// Hud Options
	setcvar("sv_playersleft", 1);
	setcvar("scr_show_healthbar", 1);
	setcvar("scr_fade_healthbar", 1); //Only works when using the healthbar obviously
	setcvar("scr_show_death_icons", 0);
	setcvar("scr_show_objective_icons", 0);
	setcvar("scr_allow_hitblip", 1);
	setcvar("scr_show_grenade_icon", 1);
	setcvar("scr_allow_hud_scoreboard", 1); //The stock one up in the upper left corner...
	setcvar("scr_showscorelimit", 1);
	//CTF
	setcvar("scr_ctf_show_compassflag", 0);
	setcvar("scr_ctf_flag_graceperiod", 30);
	setcvar("scr_ctf_positiontime", 10);
	setcvar("scr_ctf_show_flagstatus_hud", 0);


	// Health Regen & Delay
	setcvar("scr_allow_health_regen", 1); // 0= no regen, 1 is stock, and there are other options too
	setcvar("scr_regen_delay", 5000); //Time before regen starts
	setcvar("scr_allow_healthpacks", 0);

	// CTF Scoring Options
	setcvar("scr_ctf_capture_points", 10); //10 stock
	setcvar("scr_ctf_return_points", 2); //2 stock

	// Respawn on Capture
	setcvar("scr_ctf_respawn_on_capture", 1); // if on (1) everyone will respawn when a flag is captured

	// Weapon Pack
	Get_Weapon_Pack();

	// Single Shot Kills
	setcvar("scr_no_oneshot_pistol_kills", 0); 
	setcvar("scr_no_oneshot_ppsh_kills", 0);

	// PPSH Balance - Limits range of PPSH to same as Tommy
	setcvar("scr_balance_ppsh_distance", 0);

	//ShellShock
	setcvar("scr_allow_shellshock", 0);

	//Clock Position
	setcvar("scr_clock_position", 1); // 0 = stock position, 1 = CoD1 position


	// Fall Damage
	setcvar("scr_fallDamageMinHeight", 21);
	setcvar("scr_fallDamageMaxHeight", 40);

	// DVAR Enforcer
	setcvar("de_force_rate", 25000);
	setcvar("de_remove_exploits", 1); 
	setcvar("de_stock_polygonOffset", 1);
	setcvar("de_allow_enemycrosshaircolor", 0);
	setcvar("de_Sound_Ping_QuickFade", 1);
	setcvar("de_allow_mantlehint", 1);
	setcvar("de_allow_crosshair", 1);
	setcvar("de_allow_turret_crosshair", 1);
	setcvar("de_allow_crosshairnames", 1);
	setcvar("de_allow_hudstance", 1);

	// Ambients
	setcvar("scr_allow_ambient_sounds", 1);
	setcvar("scr_allow_ambient_fire", 0);
	setcvar("scr_allow_ambient_weather", 0);

	// Kill Triggers
	setcvar("scr_remove_killtriggers", 0);


	// Not Likely to Change
	setcvar("sv_pure", 1);
	setcvar("g_speed", 190);
	setcvar("g_antilag", 0);
	setcvar("g_allowvote", 0);
	setcvar("scr_friendlyfire", 1);
	setcvar("scr_freelook", 0);
	setcvar("scr_drawfriend", 1);
	setcvar("scr_teambalance", 0);
	setcvar("scr_killcam", 0);
	setcvar("scr_spectatefree", 0);
	setcvar("scr_spectateenemy", 0);
	setcvar("sv_minping", 0);
	setcvar("sv_maxping", 0);
	setcvar("sv_floodProtect", 1);
	setcvar("sv_voice", 0);
	setcvar("sv_cheats", 0);
	setcvar("g_weaponAmmoPools", 0);
	setcvar("logfile", 1);
	setcvar("sv_fps", 30);
	setcvar("scr_forcerespawn", 1);


	// DO NOT MODIFY BELOW THIS LINE!
	//game["leaguestring"] = &"ECW Match Mode-Wpk1"; //Done in Weapon Packs
	game["mode"] = "match";
}

Get_Weapon_Pack()
{
	weapon_pack = getcvarint("ecw_weaponpack");

	switch (weapon_pack)
	{
	case 2:
		Weapon_Pack_2();
		return;
	case 3:
		Weapon_Pack_3();
		return;
	case 4:
		Weapon_Pack_4();
		return;
	case 5:
		Weapon_Pack_5();
		return;
	case 6:
		Weapon_Pack_6();
		return;
	case 7:
		Weapon_Pack_7();
		return;

	default:
		Weapon_Pack_1();
		return;
	}
}

Weapon_Pack_1()
{
	// Nade Spawn Counts
	setcvar("scr_boltaction_nades", 1);
	setcvar("scr_semiautomatic_nades", 1);
	setcvar("scr_smg_nades", 1);
	setcvar("scr_sniper_nades", 1);
	setcvar("scr_mg_nades", 1);
	setcvar("scr_shotgun_nades", 1);

	// Smoke Spawn Counts
	setcvar("scr_boltaction_smokes", 0);
	setcvar("scr_semiautomatic_smokes", 0);
	setcvar("scr_smg_smokes", 0);
	setcvar("scr_sniper_smokes", 1);
	setcvar("scr_mg_smokes", 0);
	setcvar("scr_shotgun_smokes", 1);

	// Allow Weapon Drops
	setcvar("scr_allow_weapondrop_nade", 0);
	setcvar("scr_allow_weapondrop_sniper", 0);
	setcvar("scr_allow_weapondrop_shotgun", 0);

	// Secondary Weapon Drop
	setcvar("scr_allow_secondary_drop", 0);

	// Force Bolt-Action Rifles
	setcvar("scr_force_boltaction", 0);

	// Weapon Limits by class per team
	setcvar("scr_boltaction_limit", 99);
	setcvar("scr_sniper_limit", 1);
	setcvar("scr_semiautomatic_limit", 99);
	setcvar("scr_smg_limit", 99);
	setcvar("scr_mg_limit", 99);
	setcvar("scr_shotgun_limit", 1);

	// Allow/Disallow Weapons
	setcvar("scr_allow_greasegun", 1);
	setcvar("scr_allow_m1carbine", 1);
	setcvar("scr_allow_m1garand", 1);
	setcvar("scr_allow_springfield", 1);
	setcvar("scr_allow_thompson", 1);
	setcvar("scr_allow_bar", 1);
	setcvar("scr_allow_sten", 1);
	setcvar("scr_allow_enfield", 1);
	setcvar("scr_allow_enfieldsniper", 1);
	setcvar("scr_allow_bren", 1);
	setcvar("scr_allow_pps42", 1);
	setcvar("scr_allow_nagant", 1);
	setcvar("scr_allow_svt40", 1);
	setcvar("scr_allow_nagantsniper", 1);
	setcvar("scr_allow_ppsh", 1);
	setcvar("scr_allow_mp40", 1);
	setcvar("scr_allow_kar98k", 1);
	setcvar("scr_allow_g43", 1);
	setcvar("scr_allow_kar98ksniper", 1);
	setcvar("scr_allow_mp44", 1);
	setcvar("scr_allow_shotgun", 1);
	setcvar("scr_allow_fraggrenades", 1);
	setcvar("scr_allow_smokegrenades", 1);
	setcvar("scr_allow_pistols", 1);
	setcvar("scr_allow_turrets", 1);

	game["leaguestring"] = &"ECW Match Mode-Wpk1";
}

Weapon_Pack_2()
{
	// Nade Spawn Counts
	setcvar("scr_boltaction_nades", 0);
	setcvar("scr_semiautomatic_nades", 0);
	setcvar("scr_smg_nades", 0);
	setcvar("scr_sniper_nades", 0);
	setcvar("scr_mg_nades", 0);
	setcvar("scr_shotgun_nades", 0);

	// Smoke Spawn Counts
	setcvar("scr_boltaction_smokes", 0);
	setcvar("scr_semiautomatic_smokes", 0);
	setcvar("scr_smg_smokes", 0);
	setcvar("scr_sniper_smokes", 1);
	setcvar("scr_mg_smokes", 0);
	setcvar("scr_shotgun_smokes", 0);

	// Allow Weapon Drops
	setcvar("scr_allow_weapondrop_nade", 0);
	setcvar("scr_allow_weapondrop_sniper", 0);
	setcvar("scr_allow_weapondrop_shotgun", 0);

	// Secondary Weapon Drop
	setcvar("scr_allow_secondary_drop", 0);

	// Force Bolt-Action Rifles
	setcvar("scr_force_boltaction", 0);

	// Weapon Limits by class per team
	setcvar("scr_boltaction_limit", 99);
	setcvar("scr_sniper_limit", 1);
	setcvar("scr_semiautomatic_limit", 99);
	setcvar("scr_smg_limit", 0);
	setcvar("scr_mg_limit", 0);
	setcvar("scr_shotgun_limit", 0);

	// Allow/Disallow Weapons
	setcvar("scr_allow_greasegun", 0);
	setcvar("scr_allow_m1carbine", 1);
	setcvar("scr_allow_m1garand", 1);
	setcvar("scr_allow_springfield", 1);
	setcvar("scr_allow_thompson", 0);
	setcvar("scr_allow_bar", 0);
	setcvar("scr_allow_sten", 0);
	setcvar("scr_allow_enfield", 1);
	setcvar("scr_allow_enfieldsniper", 1);
	setcvar("scr_allow_bren", 0);
	setcvar("scr_allow_pps42", 0);
	setcvar("scr_allow_nagant", 1);
	setcvar("scr_allow_svt40", 1);
	setcvar("scr_allow_nagantsniper", 1);
	setcvar("scr_allow_ppsh", 0);
	setcvar("scr_allow_mp40", 0);
	setcvar("scr_allow_kar98k", 1);
	setcvar("scr_allow_g43", 1);
	setcvar("scr_allow_kar98ksniper", 1);
	setcvar("scr_allow_mp44", 0);
	setcvar("scr_allow_shotgun", 0);
	setcvar("scr_allow_fraggrenades", 1);
	setcvar("scr_allow_smokegrenades", 1);
	setcvar("scr_allow_pistols", 0);
	setcvar("scr_allow_turrets", 0);

	game["leaguestring"] = &"ECW Match Mode-Wpk2";
}

Weapon_Pack_3()
{

	// Nade Spawn Counts
	setcvar("scr_boltaction_nades", 0);
	setcvar("scr_semiautomatic_nades", 0);
	setcvar("scr_smg_nades", 0);
	setcvar("scr_sniper_nades", 0);
	setcvar("scr_mg_nades", 0);
	setcvar("scr_shotgun_nades", 0);

	// Smoke Spawn Counts
	setcvar("scr_boltaction_smokes", 0);
	setcvar("scr_semiautomatic_smokes", 0);
	setcvar("scr_smg_smokes", 0);
	setcvar("scr_sniper_smokes", 1);
	setcvar("scr_mg_smokes", 0);
	setcvar("scr_shotgun_smokes", 0);

	// Allow Weapon Drops
	setcvar("scr_allow_weapondrop_nade", 0);
	setcvar("scr_allow_weapondrop_sniper", 0);
	setcvar("scr_allow_weapondrop_shotgun", 0);

	// Secondary Weapon Drop
	setcvar("scr_allow_secondary_drop", 0);

	// Force Bolt-Action Rifles
	setcvar("scr_force_boltaction", 0);

	// Weapon Limits by class per team
	setcvar("scr_boltaction_limit", 99);
	setcvar("scr_sniper_limit", 1);
	setcvar("scr_semiautomatic_limit", 0);
	setcvar("scr_smg_limit", 0);
	setcvar("scr_mg_limit", 0);
	setcvar("scr_shotgun_limit", 0);

	// Allow/Disallow Weapons
	setcvar("scr_allow_greasegun", 0);
	setcvar("scr_allow_m1carbine", 0);
	setcvar("scr_allow_m1garand", 0);
	setcvar("scr_allow_springfield", 1);
	setcvar("scr_allow_thompson", 0);
	setcvar("scr_allow_bar", 0);
	setcvar("scr_allow_sten", 0);
	setcvar("scr_allow_enfield", 1);
	setcvar("scr_allow_enfieldsniper", 1);
	setcvar("scr_allow_bren", 0);
	setcvar("scr_allow_pps42", 0);
	setcvar("scr_allow_nagant", 1);
	setcvar("scr_allow_svt40", 0);
	setcvar("scr_allow_nagantsniper", 1);
	setcvar("scr_allow_ppsh", 0);
	setcvar("scr_allow_mp40", 0);
	setcvar("scr_allow_kar98k", 1);
	setcvar("scr_allow_g43", 0);
	setcvar("scr_allow_kar98ksniper", 1);
	setcvar("scr_allow_mp44", 0);
	setcvar("scr_allow_shotgun", 0);
	setcvar("scr_allow_fraggrenades", 0);
	setcvar("scr_allow_smokegrenades", 1);
	setcvar("scr_allow_pistols", 0);
	setcvar("scr_allow_turrets", 0);

	game["leaguestring"] = &"ECW Match Mode-Wpk3";
}
Weapon_Pack_4()
{

	// Nade Spawn Counts
	setcvar("scr_boltaction_nades", 0);
	setcvar("scr_semiautomatic_nades", 0);
	setcvar("scr_smg_nades", 1);
	setcvar("scr_sniper_nades", 0);
	setcvar("scr_mg_nades", 1);
	setcvar("scr_shotgun_nades", 0);

	// Smoke Spawn Counts
	setcvar("scr_boltaction_smokes", 0);
	setcvar("scr_semiautomatic_smokes", 0);
	setcvar("scr_smg_smokes", 0);
	setcvar("scr_sniper_smokes", 0);
	setcvar("scr_mg_smokes", 0);
	setcvar("scr_shotgun_smokes", 0);

	// Allow Weapon Drops
	setcvar("scr_allow_weapondrop_nade", 0);
	setcvar("scr_allow_weapondrop_sniper", 0);
	setcvar("scr_allow_weapondrop_shotgun", 0);

	// Secondary Weapon Drop
	setcvar("scr_allow_secondary_drop", 0);

	// Force Bolt-Action Rifles
	setcvar("scr_force_boltaction", 0);

	// Weapon Limits by class per team
	setcvar("scr_boltaction_limit", 0);
	setcvar("scr_sniper_limit", 0);
	setcvar("scr_semiautomatic_limit", 0);
	setcvar("scr_smg_limit", 99);
	setcvar("scr_mg_limit", 99);
	setcvar("scr_shotgun_limit", 0);

	// Allow/Disallow Weapons
	setcvar("scr_allow_greasegun", 1);
	setcvar("scr_allow_m1carbine", 0);
	setcvar("scr_allow_m1garand", 0);
	setcvar("scr_allow_springfield", 0);
	setcvar("scr_allow_thompson", 1);
	setcvar("scr_allow_bar", 1);
	setcvar("scr_allow_sten", 1);
	setcvar("scr_allow_enfield", 0);
	setcvar("scr_allow_enfieldsniper", 0);
	setcvar("scr_allow_bren", 1);
	setcvar("scr_allow_pps42", 1);
	setcvar("scr_allow_nagant", 0);
	setcvar("scr_allow_svt40", 0);
	setcvar("scr_allow_nagantsniper", 0);
	setcvar("scr_allow_ppsh", 1);
	setcvar("scr_allow_mp40", 1);
	setcvar("scr_allow_kar98k", 0);
	setcvar("scr_allow_g43", 0);
	setcvar("scr_allow_kar98ksniper", 0);
	setcvar("scr_allow_mp44", 1);
	setcvar("scr_allow_shotgun", 0);
	setcvar("scr_allow_fraggrenades", 1);
	setcvar("scr_allow_smokegrenades", 0);
	setcvar("scr_allow_pistols", 1);
	setcvar("scr_allow_turrets", 0);

	game["leaguestring"] = &"ECW Match Mode-Wpk4";
}

Weapon_Pack_5()
{

	// Nade Spawn Counts
	setcvar("scr_boltaction_nades", 0);
	setcvar("scr_semiautomatic_nades", 0);
	setcvar("scr_smg_nades", 0);
	setcvar("scr_sniper_nades", 0);
	setcvar("scr_mg_nades", 0);
	setcvar("scr_shotgun_nades", 0);

	// Smoke Spawn Counts
	setcvar("scr_boltaction_smokes", 0);
	setcvar("scr_semiautomatic_smokes", 0);
	setcvar("scr_smg_smokes", 0);
	setcvar("scr_sniper_smokes", 0);
	setcvar("scr_mg_smokes", 0);
	setcvar("scr_shotgun_smokes", 0);

	// Allow Weapon Drops
	setcvar("scr_allow_weapondrop_nade", 0);
	setcvar("scr_allow_weapondrop_sniper", 0);
	setcvar("scr_allow_weapondrop_shotgun", 0);

	// Secondary Weapon Drop
	setcvar("scr_allow_secondary_drop", 0);

	// Force Bolt-Action Rifles
	setcvar("scr_force_boltaction", 0);

	// Weapon Limits by class per team
	setcvar("scr_boltaction_limit", 99);
	setcvar("scr_sniper_limit", 0);
	setcvar("scr_semiautomatic_limit", 0);
	setcvar("scr_smg_limit", 0);
	setcvar("scr_mg_limit", 0);
	setcvar("scr_shotgun_limit", 0);

	// Allow/Disallow Weapons
	setcvar("scr_allow_greasegun", 0);
	setcvar("scr_allow_m1carbine", 0);
	setcvar("scr_allow_m1garand", 0);
	setcvar("scr_allow_springfield", 0);
	setcvar("scr_allow_thompson", 0);
	setcvar("scr_allow_bar", 0);
	setcvar("scr_allow_sten", 0);
	setcvar("scr_allow_enfield", 1);
	setcvar("scr_allow_enfieldsniper", 0);
	setcvar("scr_allow_bren", 0);
	setcvar("scr_allow_pps42", 0);
	setcvar("scr_allow_nagant", 1);
	setcvar("scr_allow_svt40", 0);
	setcvar("scr_allow_nagantsniper", 0);
	setcvar("scr_allow_ppsh", 0);
	setcvar("scr_allow_mp40", 0);
	setcvar("scr_allow_kar98k", 1);
	setcvar("scr_allow_g43", 0);
	setcvar("scr_allow_kar98ksniper", 0);
	setcvar("scr_allow_mp44", 0);
	setcvar("scr_allow_shotgun", 0);
	setcvar("scr_allow_fraggrenades", 0);
	setcvar("scr_allow_smokegrenades", 0);
	setcvar("scr_allow_pistols", 0);
	setcvar("scr_allow_turrets", 0);

	game["leaguestring"] = &"ECW Match Mode-Wpk5";
}
Weapon_Pack_6()
{
	// Nade Spawn Counts
	setcvar("scr_boltaction_nades", 1);
	setcvar("scr_semiautomatic_nades", 1);
	setcvar("scr_smg_nades", 1);
	setcvar("scr_sniper_nades", 1);
	setcvar("scr_mg_nades", 1);
	setcvar("scr_shotgun_nades", 1);

	// Smoke Spawn Counts
	setcvar("scr_boltaction_smokes", 1);
	setcvar("scr_semiautomatic_smokes", 1);
	setcvar("scr_smg_smokes", 1);
	setcvar("scr_sniper_smokes", 1);
	setcvar("scr_mg_smokes", 1);
	setcvar("scr_shotgun_smokes", 1);

	// Allow Weapon Drops
	setcvar("scr_allow_weapondrop_nade", 0);
	setcvar("scr_allow_weapondrop_sniper", 0);
	setcvar("scr_allow_weapondrop_shotgun", 0);

	// Secondary Weapon Drop
	setcvar("scr_allow_secondary_drop", 0);

	// Force Bolt-Action Rifles
	setcvar("scr_force_boltaction", 0);

	// Weapon Limits by class per team
	setcvar("scr_boltaction_limit", 99);
	setcvar("scr_sniper_limit", 1);
	setcvar("scr_semiautomatic_limit", 99);
	setcvar("scr_smg_limit", 99);
	setcvar("scr_mg_limit", 99);
	setcvar("scr_shotgun_limit", 1);

	// Allow/Disallow Weapons
	setcvar("scr_allow_greasegun", 1);
	setcvar("scr_allow_m1carbine", 1);
	setcvar("scr_allow_m1garand", 1);
	setcvar("scr_allow_springfield", 1);
	setcvar("scr_allow_thompson", 1);
	setcvar("scr_allow_bar", 1);
	setcvar("scr_allow_sten", 1);
	setcvar("scr_allow_enfield", 1);
	setcvar("scr_allow_enfieldsniper", 1);
	setcvar("scr_allow_bren", 1);
	setcvar("scr_allow_pps42", 1);
	setcvar("scr_allow_nagant", 1);
	setcvar("scr_allow_svt40", 1);
	setcvar("scr_allow_nagantsniper", 1);
	setcvar("scr_allow_ppsh", 1);
	setcvar("scr_allow_mp40", 1);
	setcvar("scr_allow_kar98k", 1);
	setcvar("scr_allow_g43", 1);
	setcvar("scr_allow_kar98ksniper", 1);
	setcvar("scr_allow_mp44", 1);
	setcvar("scr_allow_shotgun", 1);
	setcvar("scr_allow_fraggrenades", 1);
	setcvar("scr_allow_smokegrenades", 1);
	setcvar("scr_allow_pistols", 1);
	setcvar("scr_allow_turrets", 1);

	game["leaguestring"] = &"ECW Match Mode-Wpk6";
}
Weapon_Pack_7()
{

	// Nade Spawn Counts
	setcvar("scr_boltaction_nades", 0);
	setcvar("scr_semiautomatic_nades", 0);
	setcvar("scr_smg_nades", 0);
	setcvar("scr_sniper_nades", 0);
	setcvar("scr_mg_nades", 1);
	setcvar("scr_shotgun_nades", 0);

	// Smoke Spawn Counts
	setcvar("scr_boltaction_smokes", 0);
	setcvar("scr_semiautomatic_smokes", 0);
	setcvar("scr_smg_smokes", 0);
	setcvar("scr_sniper_smokes", 0);
	setcvar("scr_mg_smokes", 0);
	setcvar("scr_shotgun_smokes", 0);

	// Allow Weapon Drops
	setcvar("scr_allow_weapondrop_nade", 0);
	setcvar("scr_allow_weapondrop_sniper", 0);
	setcvar("scr_allow_weapondrop_shotgun", 1);

	// Secondary Weapon Drop
	setcvar("scr_allow_secondary_drop", 0);

	// Force Bolt-Action Rifles
	setcvar("scr_force_boltaction", 0);

	// Weapon Limits by class per team
	setcvar("scr_boltaction_limit", 0);
	setcvar("scr_sniper_limit", 0);
	setcvar("scr_semiautomatic_limit", 0);
	setcvar("scr_smg_limit", 0);
	setcvar("scr_mg_limit", 0);
	setcvar("scr_shotgun_limit", 99);

	// Allow/Disallow Weapons
	setcvar("scr_allow_greasegun", 0);
	setcvar("scr_allow_m1carbine", 0);
	setcvar("scr_allow_m1garand", 0);
	setcvar("scr_allow_springfield", 0);
	setcvar("scr_allow_thompson", 0);
	setcvar("scr_allow_bar", 0);
	setcvar("scr_allow_sten", 0);
	setcvar("scr_allow_enfield", 0);
	setcvar("scr_allow_enfieldsniper", 0);
	setcvar("scr_allow_bren", 0);
	setcvar("scr_allow_pps42", 0);
	setcvar("scr_allow_nagant", 0);
	setcvar("scr_allow_svt40", 0);
	setcvar("scr_allow_nagantsniper", 0);
	setcvar("scr_allow_ppsh", 0);
	setcvar("scr_allow_mp40", 0);
	setcvar("scr_allow_kar98k", 0);
	setcvar("scr_allow_g43", 0);
	setcvar("scr_allow_kar98ksniper", 0);
	setcvar("scr_allow_mp44", 0);
	setcvar("scr_allow_shotgun", 1);
	setcvar("scr_allow_fraggrenades", 0);
	setcvar("scr_allow_smokegrenades", 0);
	setcvar("scr_allow_pistols", 0);
	setcvar("scr_allow_turrets", 0);

	game["leaguestring"] = &"ECW Match Mode-Wpk7";
}